#include <msp/graphics/window_private.h>
#include "keyboard.h"
#include "keys_private.h"

using namespace std;

namespace Msp {
namespace Input {

string Keyboard::get_button_name(unsigned btn) const
{
	return Device::get_button_name(btn);
}

void Keyboard::input_event(const Graphics::Window::Event &event)
{
	switch(event.cevent.type)
	{
	case KEY_DOWN:
	case KEY_UP:
		if(unsigned key = key_from_sys(event.cevent.key.key))
			set_button_state(key, event.cevent.type==KEY_DOWN, true);
		if(event.cevent.type==KEY_DOWN && event.cevent.key.character>0)
			signal_character.emit(event.cevent.key.character);
		break;
	default:;
	}
}

} // namespace Inpus
} // namespace Msp
